<template>
  <div class="_container">
    <rui-empty v-if="Object.keys(groups).length === 0" :content="$t('js.harvests.no_harvests')" />

    <table v-else class="gpa-harvests-table -mtl">
      <thead>
        <tr>
          <th />
          <th v-for="year in years"
              :key="year"
              class="-text--right"
              :class="year !== years[0] ? '-sm-l:hidden' : ''"
              colspan="4">
            {{ year }}
          </th>
        </tr>
      </thead>
      <tbody>
        <template v-for="group in groups" :key="group.resource.id">
          <tr>
            <th :colspan="years.length * 4 + 1">
              <span class="-flex -gap">
                <img :src="group.resource.picturePath" alt="">
                {{ group.resource.name }}
              </span>
            </th>
          </tr>
          <tr v-for="(data, unit) in group.sums" :key="unit" class="_gpa-harvest-variation">
            <td />
            <gpa-harvest-variation v-for="year in years"
                                   :key="year"
                                   :cell-class="year !== years[0] ? '-sm-l:hidden' : ''"
                                   :value="data[year]"
                                   :unit="unit"
                                   :previous="data[year - 1]" />
          </tr>
        </template>
      </tbody>
    </table>
  </div>
</template>

<script>
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import Harvest from '@/vue/classes/models/Harvest'
import GpaHarvestVariation from './Harvests/_Variation.vue'

export default {
  name: 'GpaHarvests',
  components: { RuiEmpty, GpaHarvestVariation },
  data () {
    const currentYear = new Date().getFullYear()

    return {
      loading: false,
      error: null,
      years: [currentYear, currentYear - 1, currentYear - 2],
      groups: {},
    }
  },
  methods: {
    groupHarvests (harvests) {
      const emptyYears = {}
      this.years.forEach(y => { emptyYears[y] = 0 })
      const out = {}

      harvests.forEach((h) => {
        const element = this.$store.getters.element(h.elementId)
        const year = h.harvestedAt.getFullYear()

        if (!out[element.resourceId]) {
          out[element.resourceId] = {
            resource: element.resource,
            sums: { },
          }
        }
        if (!out[element.resourceId].sums[h.unit]) out[element.resourceId].sums[h.unit] = { ...emptyYears }

        out[element.resourceId].sums[h.unit][year] += h.quantity
      })

      this.groups = out
    },
  },
  created () {
    this.loading = true
    this.error = null
    Harvest.getMapIndex(this.$route.params.mapId)
      .then((harvests) => { this.groupHarvests(harvests) })
      .catch((error) => { this.error = error })
      .then(() => { this.loading = false })
  },
}
</script>

<style lang="scss" src="./Harvests.scss" />
